%Chaine de Markov
clear all
clc

n = 10; % Taille du systeme
N = 100; % Nb de simulation

cc =zeros(1,n-1); % indicateur du nb de fois ou on a visite le noeud i 
p =zeros(1,n-1); % proba de sortie en 0

for k=1:N
lis = zeros(1,n-1); 
l = []; 
c = 0;
i  =n/2;
lis(i) = 1;   % Indicateur de visite du noeud i = 1 si visite 0 sinon
while (i>0 && i<n) 
  c = c+1;
  l(c) = i; % Trajectoire jusqu'au point de sortie
  a = rand(1,1);
  lis(i) = 1;
  if (a>=0.5) 
    i = i+1;
  else
    i = i-1;
  end
end
for j=1:n-1 % nb de fois ou on a visite un point 
  cc(j) = cc(j)+lis(j);
end
if (i==0) 
  for i=1:n-1 % score  +1 uniquement les noeuds visites
    p(i) = p(i)+lis(i);
  end
end

end

p = p./cc; % proba de sorti en 0 







a = 0;
b = 1;
u = a*p+(1-p)*b;
x  =[a:1/n:b];
uex = a + (b-a)*x;
plot(x(1:end),[a u b] ,x,uex) 
legend('sol approchee','sol exacte')




